# Keyboard And Mouse Interactive Dataset

# Neural Network

## Train 

Set training parameters in train.sh

Run `sh train.sh` to train the model


## Test

Run `sh test.sh` to run test on trained model

Predictions are saved under `prediction/task$i$/`


# Split Prediction

Run `sh sampler_user.sh` to split prediction to 10% to 90%

Run `sh sampler_single_act.sh` to split prediction individual action sequences.


# Bayesian Inference


Run inference to get results of intention prediction for all users and plot results
```
cd stan
Rscript strategy_inference_test.R
sh plot_user.sh
```

Run inference to get results of intention prediction (0% to 100%) for all users and plot results

```
Rscript strategy_inference_test_full_length.R
sh plot_user_length_10_steps.sh
```

Run inference to get all action sequences (0% to 100%) of all users for intention prediction

```
Rscript strategy_inference_test_all_individual_act.R
```

Plot results of user intention prediction of all action sequences

```
sh plot_user_all_individual.sh
```

Plot the user intention prediction results (0% to 100%) of all action sequences

```
sh plot_user_length_10_steps_all_individual.sh





